$(function () {
    var challenge = {
        init: function () {
            this.render();
            this.bindEvent();
        },
        render: function () {
            $('title').text(_AN_str_title_challenge);
            $('#title').text(_AN_str_info_chal);
            $('#signin').text(_AN_str_signin);
            $('label[for="pwd"]').text(_AN_str_password);
            $('#cancel').text(_AN_str_cancel);
            if (_AN_str_errmsg_chal.length > 0) {
                $('#msgBox').show();
                $('#infoMsg').text(_AN_str_errmsg_chal);
            } else {
                $('#msgBox').hide();
            }
        },
        bindEvent: function () {
            $('#signin').on('click', this.signin.bind(this));
            $('#closeMsg').on('click', this.closeMsg.bind(this));
            $('#cancel').on('click', function () {
                window.location = "/prx/000/http/localhost/login/index.html";
                return false;
            })
        },
        signin: function () {
            $('#passForm').submit();
        },
        infoMsg: function (msg) {
            $('#msgBox').removeClass('hide');
            $('#infoMsg').text(msg);
        },
        closeMsg: function () {
            $('#msgBox').addClass('hide');
        }
    }
    challenge.init();
})